#include "main.h"
#include "FD2E.h"

/**
	* ʱȭ
*/

extern pthread_t thread_for_event;
extern void* thread_result_for_event;
extern clnt g_clntent[MAX_CLIENT];
extern int g_device_status;					
extern int g_epoll_fd;						
extern int g_serv_sockfd;              

extern clnt g_clntent[MAX_CLIENT];
extern int g_serv_port;
extern pthread_mutex_t mutx;
extern struct epoll_event g_events[MAX_CLIENT];

T_CCI_ERROR error;
T_CCI_COL_INFO *res_col_info;
T_CCI_SQLX_CMD cmd_type;

/***************************************************************
// Ŭ̾Ʈ  ũ ʱȭ
***************************************************************/
void init_data(void)
{
	register int i;
	for(i = 0; i < MAX_CLIENT; i++)
	{
		g_clntent[i].clnt_sockfd = -1;		//Ŭ̾Ʈ  ũ ʱȭ
	}
}

/***************************************************************
//   ũ ʱȭ
***************************************************************/
void init_server(int serv_port)
{
	g_device_status = 0;					//  ũ ʱȭ
	struct sockaddr_in serv_addr;			// ּ   ü  
	if( (g_serv_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)	//TCP   
	{
		printf("[OWL] Server start fails. : Can't open stream socket \n");
		exit(0);
	}
	
	memset(&serv_addr, 0, sizeof(serv_addr));		//ּҸ  ü  ʱȭ

	serv_addr.sin_family = AF_INET;					//ͳ ּü 
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);	//IP ּ 
	serv_addr.sin_port = htons(serv_port);			//PORT ȣ 

	int nSocketOpt = 1;

	//̹ Ǵ ּҸ ε   ֵ  ɼ 
	if( setsockopt(g_serv_sockfd, SOL_SOCKET, SO_REUSEADDR, &nSocketOpt, sizeof(nSocketOpt)) < 0)	
	{
		printf("[OWL] Server start failes. : Can't open reuse address \n");
		close(g_serv_sockfd);
		exit(0);
	}

	if( bind(g_serv_sockfd, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) < 0)	//  ּҿ  ε
	{
		printf("[OWL] Server start fails. : Can't bind local address \n");
		close(g_serv_sockfd);
		exit(0);
	}
	
	listen(g_serv_sockfd, 15);	//Ŭ̾Ʈ  

	printf("[OWL][START] Now server listening on port %d\n", g_serv_port);
}

/***************************************************************
// ̺Ʈ  
***************************************************************/
void epoll_init(void)
{
	struct epoll_event events;

	g_epoll_fd = epoll_create(MAX_EVENTS);		//̺Ʈ  
	if(g_epoll_fd < 0)
	{
		printf("[OWL] Epoll create fails.\n");
		close(g_serv_sockfd);
		exit(0);
	}
	printf("[OWL][START] epoll creation success.\n");
	events.events = EPOLLIN;
	events.data.fd = g_serv_sockfd;

	//̺Ʈ  ũ  : ̺Ʈ ߻Ͽ ̺Ʈ   
	if( epoll_ctl(g_epoll_fd, EPOLL_CTL_ADD, g_serv_sockfd, &events) < 0)		
	{
		printf("[OWL] Epoll control fails.\n");
		close(g_serv_sockfd);
		close(g_epoll_fd);
		exit(0);
	}
	printf("[OWL][START] Epoll events set success for server.\n");
}

/***************************************************************
// Ŭ̾Ʈ  ̺Ʈ  ߰
***************************************************************/
void epoll_clnt_add(int clnt_fd)
{
	struct epoll_event events;

	events.events = EPOLLIN;
	events.data.fd = clnt_fd;

	if(epoll_ctl(g_epoll_fd, EPOLL_CTL_ADD, clnt_fd, &events) < 0)		//
	{
		printf("[OWL] Epoll control fails in epoll_clnt_add. \n");
	}
}

/***************************************************************
//  Ǯ  Ŭ̾Ʈ  ũ 
***************************************************************/
void userpool_add(int clnt_fd, char* clnt_ip)
{
	register int i;
	for( i = 0; i < MAX_CLIENT; i++)			//Ŭ̾Ʈ  ˻, ִ Ŭ̾Ʈ   ִ  
	{
		if(g_clntent[i].clnt_sockfd == -1) break;
	}
	if( i >= MAX_CLIENT) close(clnt_fd);		//Ŭ̾Ʈ  ִ 밪  Ŭ̾Ʈ  

	g_clntent[i].clnt_sockfd = clnt_fd;			//Ŭ̾Ʈ  ũ 
	memset(&g_clntent[i].clnt_ip[0], 0, 20);	//  ʱȭ
	strcpy(&g_clntent[i].clnt_ip[0], clnt_ip);	//Ŭ̾Ʈ  ּ Ҵ
}

/***************************************************************
// Ŭ̾Ʈ   Ǯ Ŭ̾Ʈ  
***************************************************************/
void userpool_delete(int clnt_fd)
{
	register int i;
	for( i = 0; i < MAX_CLIENT; i++)
	{
		if(g_clntent[i].clnt_sockfd == clnt_fd)		//ϴ Ŭ̾Ʈ  
		{
			g_clntent[i].clnt_sockfd = -1;
			break;
		}
	}
}

/***************************************************************
*Ŭ̾Ʈ   ( : Ʈ ĳ)
*  : ڿ
	
2007-11-01 ȣ 
* Ư Ŭ̾Ʈ Data 䱸   Ŭ̾Ʈ ָ ȵȴ. 
*׷Ƿ Ư Ŭ̾ƮԸ   ִ privateuser_send Լ ش. ڴ buffer, size, sockfd  ϸ ɰ .

2007-11-03  
*size ڸ ߰Ͽ. strlen ڿ̸    찡 ִ. buffer Ϳ պκп (packettype, packetsize)
*   ڿ ġ  ڿ "\0" Ⱥ̴ 찡   ִ. 
* ׷Ƿ Ȯϰ óϱ  userpool_send ȣϴ Լ  buffer  .

*Mutex Ͽ sendԼ յڷ Critical Section ߰Ͽ. ̴ SendAccident Լó ڵ Alarmϴ (EventProcess Thread) 
* û SensorInfo Լ(Main Լ, Server_Process)  userpool_send ȣϱ  send ľ  ִ. 
*send Thread Safe Լ ƴϱ  Critical Section ʿϴ.

*Buffer ʱȭ userpool_send å̴.
***************************************************************/
void userpool_send(char* buffer, int size)
{
	register int cnt;
	int len = 0;

	for(cnt = 0; cnt < MAX_CLIENT; cnt++)
	{
		if(g_clntent[cnt].clnt_sockfd != -1)		//  Ŭ̾Ʈ Ͽ  
		{
			len = send(g_clntent[cnt].clnt_sockfd, buffer, size, 0);
		}
	}
}

/***************************************************************
//   
//    ũͿ Ŭ̾Ʈ  
// Ŭ̾Ʈ  ϸ, Ŭ̾Ʈ ûϴ ͸ мϿ ϴ ͸ óϿ 
***************************************************************/
void server_process()
{
	struct sockaddr_in clnt_addr;
	int i;
	int nfds;
	int clnt_sockfd;
	int clnt_len = sizeof(clnt_addr);
	int nReadCnt;
	char buffer[20];
	
	// ̺Ʈ  ̺Ʈ ߻ϴ ˻
	nfds = epoll_wait(g_epoll_fd, g_events, MAX_EVENTS, 100);		

	if(nfds == 0) return;
	if(nfds < 0)
	{
		printf("[OWL] Epoll wait error.\n");
		return;
	}

	for( i = 0; i < nfds; i++)
	{
		if(g_events[i].data.fd == g_serv_sockfd)
		{
			//Ŭ̾Ʈ  
			clnt_sockfd = accept(g_serv_sockfd, (struct sockaddr*)&clnt_addr, (socklen_t*)&clnt_len);		
			if(clnt_sockfd < 0)
			{
				/* Through */
			}
			else
			{
				printf("[OWL][Accept] New Client connected fd %d, ip %s\n", clnt_sockfd, inet_ntoa(clnt_addr.sin_addr)); 
				//user pool Ŭ̾Ʈ   
				userpool_add(clnt_sockfd, inet_ntoa(clnt_addr.sin_addr));
				//̺Ʈ  Ŭ̾Ʈ ũ 
				epoll_clnt_add(clnt_sockfd);										
			}
			
			continue;
		}
		else 
		{
			memset(buffer, '\0', sizeof(buffer));
      
			// Ŷ Type, Size ޴´. 8Byte ŭ  ߰ Ŷ   Sizeŭ Read Ѵ
			nReadCnt = read(g_events[i].data.fd, buffer, 8);		//Ŭ̾Ʈ   û 
			
			/* more precise code needed here */
			//Ŭ̾Ʈ  Ῥ ޾ 
			if(nReadCnt <= 0)
			{
				printf("[OWL][Accept] Close Client connection fd %d\n", g_events[i].data.fd);
				//Ŭ̾Ʈ     
				epoll_ctl(g_epoll_fd, EPOLL_CTL_DEL, g_events[i].data.fd, g_events);		
				close(g_events[i].data.fd);
			}
			else
			{
				/* 2007-11-03
				 *    ó ؾѴ. û Ŷ̱   ټ  û Ŭ̾ƮԸ ͸ ϴ ̴
				 *׷Ƿ û Ŭ̾Ʈ   sockfd   ʿ䰡 ִ. DataParsing Լ sockfd Ŷ  ִ buffer 
				 */
				DataParsing(g_events[i].data.fd, buffer);
				memset(buffer, '\0', sizeof(buffer));
			}
		}
	}
}

/***************************************************************
// DataParsing
// Ŭ̾Ʈ  Ŷ   κ 8byte 
// ޼ Ͽ شϴ Լ ȣѴ.
***************************************************************/
int DataParsing(int sockfd, char* message)
{
  	int packettype;
  	int packetsize;
	int connect = 0;
	int temp;
    	
  	memcpy(&packetsize, message, 4);
  	memcpy(&packettype, message+4, 4);
	
	/* 2007-11-03
	   * Pakcetsize 0̶ readԼ   ̴.
	   * size  buffer malloc ؼ  ȯؾ Ұ̴.
	   )
	   char *buffer;
	   buffer = (char*)malloc(sizeof(char)*packetsize);
		*  迭 buffer Ͽ.
		* Read Լ  Ƿ  Լ Read Ѵ.
		*  Լ ڰ buffer  ʿ䰡 ִ. 
		*  socket Լ ó server_process, define_packet, user_pool  ó ʿ䰡 ִ.
		* define_packet packet  ϱ  wrapper Լ̴.
	*  */
	
	/** PacketType   Լ з
	  * 1100 => DirLog ٿ޴´.
	  * 1200 => FileLog ٿ޴´.
	*/
	
  	switch(packettype)
  	{
    	case 1100: 
			//DirLog ޱ
			RecvDirLog(sockfd, packetsize);
 		break;

		case 1200: 

			connect = Curbrid_Connection();
			//FileLog ޱ
			RecvFileLog(sockfd, packetsize);
			FileLogRead(sockfd, connect);
			SendFileListClient(sockfd);
			Cubrid_DisConnection(connect);	// DB Disconnect
		break;
			
		case 1300:
			// client  				
			RecvTempFile(sockfd, packetsize);
		break;

		case 4000:
			Define_Packet(10000, "End\n");
			//  
				
			userpool_delete(sockfd);
			printf("close socket\n");
		break;

		case 5000:
			Define_Packet(10000, "End\n");
			//  
			// ̵  ̸  
			//ӽ÷ 
			temp = sockfd;
			userpool_delete(sockfd);
			printf("close socket\n");
			printf("Start DDF\n");
					
			StartDeduplicateFile(temp);
		break;

		case 6000:
			connect = Curbrid_Connection();
			getListDBQuery(connect, sockfd);
			// DB Disconnect
			Cubrid_DisConnection(connect);
			break;
		case 6500:
			Spec_Packet(4000, 0);
			break;
		case 7000:
			SendRestoreFiles(sockfd, packetsize);
			break;
  	}
	return 0;
}

/***************************************************************
// û  Ŭ̾Ʈ 
// filehash(SHA1)  Ͽ ͺ̽ ˻
***************************************************************/
int SendRestoreFiles(int sockfd, int packetsize)
{
	
	char buf[50];
	char query[300];

	memset(buf, '\0', 50);
	memset(query, '\0', 300);
	
	// filename read
	read(sockfd, buf, 40);	

	// DB Select query
	int nColCount = 0, nLen = 0;
    int nDB = 0, nReq = 0; 
	
	Byte pszBuff[BUFFSIZE];

	int repohandle;
	int test = 0;
	
	u_int64_t bpos = 0;
	int blength = 0;
	int fl;

	unsigned char out[BUFFSIZE];
	unsigned char in[BUFFSIZE];
	
	uLongf flength;
	
	char buffer[5];
	int err;
	int readcnt = 0;
	
    T_CCI_ERROR cciErr;
    T_CCI_COL_INFO *pcciCol;
    T_CCI_SQLX_CMD cciCmdType;
    
	//  ۼ
	sprintf(query, "select b.pos, b.blength from block as b, restorefile as r where r.fhash = '%s'and r.blocksha1 = b.blocksha1 order by r.bidx asc",
			buf);
	
	//  ̽ 
    assert((nDB = cci_connect("210.115.226.88", 30000, "owl", "DBA", "azws")) >= 0);
    assert((nReq = cci_prepare(nDB, query, 0, &cciErr)) >= 0);
    assert((pcciCol = cci_get_result_info(nReq, &cciCmdType, &nColCount)) != NULL);
    assert(cci_execute(nReq, 0, 0, &cciErr) >= 0);
	
	if((repohandle = open("./REPO/Result", O_RDONLY , 0644)) == -1)
	{
		printf("repohandle Access Error - sockfd:%d\n",sockfd);
	}

    while (1) 
    {
		//  ʱȭ
        memset(out, '\0', BUFFSIZE);
		memset(in, '\0', BUFFSIZE);
		memset(pszBuff, '\0', BUFFSIZE);
		
		if ( cci_cursor(nReq, 1, CCI_CURSOR_CURRENT, &cciErr) == CCI_ER_NO_MORE_DATA )
            break;
       
		// ̺  
		assert(cci_fetch(nReq, &cciErr) >= 0);
		assert(cci_get_data(nReq, 1, CCI_A_TYPE_BIGINT, &bpos, &nLen) >= 0);
		assert(cci_get_data(nReq, 2, CCI_A_TYPE_INT, &blength, &nLen) >= 0);

		//   ̵
		lseek(repohandle, bpos, SEEK_SET);
		readcnt = read(repohandle, pszBuff, blength);

		//  ʱȭ
		flength = BUFFSIZE;

		//  
		err = uncompress(out, &flength, pszBuff, blength);
		CHECK_ERR_RETURN(err, "uncompress");

		memset(buffer, '\0', 5);
		fl = (int)flength;
  		memcpy(buffer, &fl, 4);
		
		userpool_send(buffer, 4);
		userpool_send((char *)out, fl);
	}
	
	//  ޽ 
	memset(buffer, '\0', 5);
  	memcpy(buffer, &test, 4);
	userpool_send(buffer, 4);
	
	//  ̽  
    assert(cci_close_req_handle(nReq) >= 0);
    assert(cci_disconnect(nDB, &cciErr) >= 0);
	
	//  ڵ ݾ
	close(repohandle);
	return 1;
}

/***************************************************************
// Ŭ̾Ʈ Ǿ ִ ϸ 
***************************************************************/
void getListDBQuery(int nDB, int sockfd)
{
	int nColCount = 0, nLen = 0;
    int i = 0, nReq = 0; 
	char *pszBuff = NULL;	
	int filehandle = 0;
	
	char filepath[200];
	char writebuff[200];
	memset(filepath, '\0', 200);
	memset(writebuff, '\0', 200);


	int filesize;

    T_CCI_ERROR cciErr;
    T_CCI_COL_INFO *pcciCol;
    T_CCI_SQLX_CMD cciCmdType;
        
    assert((nReq = cci_prepare(nDB, "SELECT fname, fhash FROM backupfile", 0, &cciErr)) >= 0);
    assert((pcciCol = cci_get_result_info(nReq, &cciCmdType, &nColCount)) != NULL);
        
    for (i = 1; i <= nColCount; i++)
    {
        printf("%s\t", CCI_GET_RESULT_INFO_NAME(pcciCol, i));
    }

    printf("\n");

    assert(cci_execute(nReq, 0, 0, &cciErr) >= 0);
	

	sprintf(filepath, "./LOG/backupList%d.txt", sockfd);
	if((filehandle = open64(filepath, O_WRONLY | O_TRUNC | O_CREAT, 0644)) == -1)
	{
		printf("backupList Access Error\n");
	}
	

    while (1) 
    {
        if ( cci_cursor(nReq, 1, CCI_CURSOR_CURRENT, &cciErr) == CCI_ER_NO_MORE_DATA )
            break;
       
        assert(cci_fetch(nReq, &cciErr) >= 0);
       
        for (i = 1; i<= nColCount; i++)
        {
			memset(writebuff, '\0', 200);
			assert(cci_get_data(nReq, i, CCI_A_TYPE_STR, &pszBuff, &nLen) >= 0);
            
			sprintf(writebuff, "%s\n", conversion_iconv(pszBuff, "UTF-8", "UTF-8"));
			write(filehandle, writebuff, strlen(writebuff));
        }
    }
	
	assert(cci_close_req_handle(nReq) >= 0);

	close(filehandle);

	if((filehandle = open(filepath, O_RDONLY , 0644)) == -1)
	{
		printf("backupList Access Error - sockfd:%d\n",sockfd);
	}

	filesize = lseek(filehandle, 0, SEEK_END);
	lseek(filehandle, 0, SEEK_SET);

	Spec_Packet(3000, filesize);

	SendFile(sockfd, filesize, filehandle);

	close(filehandle);
}

/***************************************************************
// 带 ׽Ʈ   Լ
***************************************************************/
void* t_function(void *data)
{
	int sockid;

	sockid = *((int*)data);
	
	StartDeduplicateFile(sockid);

	return data;
}

/***************************************************************
// ߺ  
***************************************************************/
void StartDeduplicateFile(int sockfd)
{
	int cnt = 0;
	int line = 0;
	int filehandle;
	char ch[1];
	char filepath[100];
	char filehash[50];
		
	memset(filepath, '\0', 100);
	memset(filehash, '\0', 50);

	sprintf(filepath, "./LOG/dedupleFile%d.txt", sockfd);

	if((filehandle = open(filepath, O_RDONLY , 0644)) == -1)
	{
		printf("dedupFile Access Error - sockfd:%d\n",sockfd);
	}
			
	while( read(filehandle, ch, 1) != 0)
	{
		// ڿ  
		if(ch[0] == '\n')
		{
			cnt = 0;
			line++;
			
			if(line == 2)
			{
				//  ߺ  Լ ȣ
				CoreDeduplicateFile(filehash);

				memset(filehash, '\0', sizeof(filehash));
				line = 0;
			}
		}
		else if(ch[0] != '\n')
		{
			if(line == 0)
			{
				
			}
			else if(line == 1)		
			{
				filehash[cnt] = ch[0];
				cnt++;
			}
		}
	}
	
	// ݱ
	close(filehandle);
}

/***************************************************************
// ߺ Ͽ ҿ  
//  ʿ Ÿ͸ Բ Ѵ.
***************************************************************/
void CoreDeduplicateFile(char* filename)
{
	int filehandle, repohandle;
	char filepath[100];

	memset(filepath, '\0', 100);
	
	
	sprintf(filepath, "./TEMP/%s", filename);

	if((filehandle = open(filepath, O_RDONLY , 0644)) == -1)
	{
		printf("TEMPFile Access Error filename:%s\n",filename);
	}
	
	// ߺ
	DBC_FS(filehandle);	

	strcpy(filepath, "./REPO/Result");
	//sprintf(filepath, "./REPO/Result");
	if((repohandle = open64(filepath, O_WRONLY | O_APPEND | O_CREAT, 0644)) == -1)
	{
		printf("repohandle Access Error\n");
	}

	//  Ͽ 
	Zlib_Blk_Comp(filehandle, repohandle, filename);

	close(repohandle);
	close(filehandle);
}

/***************************************************************
// ӽ   
***************************************************************/
void RecvTempFile(int sockfd, int packetsize)
{
	
	int filehandle;
	char buf[50];
	char filepath[100];

	memset(buf, '\0', 50);

	read(sockfd, buf, 40);

	sprintf(filepath, "./TEMP/%s", buf);

	if((filehandle = open(filepath, O_WRONLY | O_TRUNC | O_CREAT, 0644)) == -1)
	{
		printf("TempFile Access Error\n");
	}

	RecvBiFile(sockfd, packetsize-40, filehandle);
}

/***************************************************************
// ڰ  û  ߿ ߺ  
***************************************************************/
void SendFileListClient(int sockfd)
{
	char filepath[100];
	int filehandle;
	int filesize;

	printf("FileList uploading.....\n");
	memset(filepath, '\0', sizeof(filepath));
	sprintf(filepath, "./LOG/dedupleFile%d.txt", sockfd);
						
	if((filehandle = open(filepath, O_RDONLY , 0644)) == -1)
	{
		printf("dedupleFile Access Error\n");
	}
	
	filesize = lseek(filehandle, 0, SEEK_END);
	lseek(filehandle, 0, SEEK_SET);
					
	if(filesize > 0)
	{
		Spec_Packet(2000, filesize);
		SendFile(sockfd, filesize, filehandle);
	}
	else
	{
		//  , ߺ  ٸ  
		Define_Packet(9000, "End\n");
		userpool_delete(sockfd);
		printf("close socket\n");
		
		close(filehandle);
	}
}

/***************************************************************
// DB  
***************************************************************/
void Cubrid_DisConnection(int con)
{
	int res;

	if ((res=cci_disconnect(con, &error))<0) {
          printf( "%s(%d): cci_disconnect fail(%d)", __FILE__, __LINE__,error.err_code);
          //goto handle_error;
    }

	printf("DB DisConnection.. \n");
}

/***************************************************************
// DB 
***************************************************************/
int Curbrid_Connection()
{
	int con = 0; 

	char *ip = "210.115.226.88";
	char *db = "owl";
	char *id = "DBA";
	char *pa = "azws";

	// CUBRID  Ʈ 30000  !!
	if ((con=cci_connect(ip, 30000, db, id, pa))<0) {
        printf( "%s(%d): cci_connect fail\n", __FILE__, __LINE__);
        return -1;
    }
    else
    {
        printf("DB Connection success..\n");
    }

	return con;
}

/***************************************************************
// Ŭ̾Ʈ   ϸ 
***************************************************************/
void SendDedupleFile(int sockfd)
{
	char filepath[20];
	int filehandle;
	int filesize;
	
	printf("dedupleFile uploading.....\n");
	strcpy( filepath, "./LOG/dedupleFile.txt");
						
	if((filehandle = open(filepath, O_RDONLY , 0644)) == -1)
	{
		printf("dedupleFile Access Error\n");
	}
	
	filesize = lseek(filehandle, 0, SEEK_END);
	lseek(filehandle, 0, SEEK_SET);
					
	if(filesize > 0)
	{
		Spec_Packet(2000, filesize);
		SendFile(sockfd, filesize, filehandle);
	}
	else
	{
		Define_Packet(9000, "End\n");
		//  
		userpool_delete(sockfd);
		printf("close socket\n");
	}
}

void SendBlockInfo(int sockfd)
{
	char filepath[20];
	int filehandle;
	int filesize;
	
	printf("BlockInfofile uploading.....\n");
	sprintf(filepath, "./LOG/BlockInfo%d.txt", sockfd);
						
	if((filehandle = open(filepath, O_RDONLY , 0644)) == -1)
	{
		printf("dedupleFile Access Error\n");
	}
	
	filesize = lseek(filehandle, 0, SEEK_END);
	lseek(filehandle, 0, SEEK_SET);
					
	if(filesize > 0)
	{
		Spec_Packet(4000, filesize);
		SendFile(sockfd, filesize, filehandle);

		Define_Packet(9000, "End\n");
		//  
		userpool_delete(sockfd);
		printf("close socket\n");
	}
	else
	{
		Define_Packet(9000, "End\n");
		//  
		userpool_delete(sockfd);
		printf("close socket\n");
	}
}

/***************************************************************
// 丮 α ޱ
***************************************************************/
void RecvDirLog(int sockfd, int packetsize)
{
	char filepath[100];
	int filehandle;
	
	memset(filepath, '\0', 100);
	printf("dirlog downloading.....\n");
	sprintf(filepath, "./LOG/dirlog%d.txt", sockfd);
						
	if((filehandle = open(filepath, O_WRONLY | O_TRUNC | O_CREAT, 0644)) == -1)
	{
		printf("DirFile Access Error\n");
	}
	
			
	RecvFile(sockfd, packetsize, filehandle);
}

/***************************************************************
//  α ޱ
***************************************************************/
void RecvFileLog(int sockfd, int packetsize)
{
	char filepath[20];
	int filehandle;
	
	printf("filelog downloading.....\n");
	//strcpy( filepath, "./LOG/filelog.txt");
	sprintf(filepath, "./LOG/filelog%d.txt", sockfd);
		
	if((filehandle = open(filepath, O_WRONLY | O_TRUNC  | O_CREAT, 0644)) == -1)
	{
		printf("DirFile Access Error\n");
	}
					
	RecvFile(sockfd, packetsize, filehandle);
}

/***************************************************************
//  α ޱ
***************************************************************/
void RecvBlockLog(int sockfd, int packetsize)
{
	char filepath[20];
	int filehandle;
	
	printf("blocklog downloading.....\n");
	strcpy( filepath, "./LOG/blocklog.txt");
		
	if((filehandle = open(filepath, O_WRONLY | O_TRUNC  | O_CREAT, 0644)) == -1)
	{
		printf("Block Log File Access Error\n");
	}
					
	RecvFile(sockfd, packetsize, filehandle);
}

/***************************************************************
//    
***************************************************************/
void RecvRestoreInfo(int sockfd, int packetsize)
{
	char filepath[40];
	int filehandle;
	
	printf("restorelog downloading.....\n");
	sprintf(filepath, "./LOG/restorelog%d.txt", sockfd);
		
	if((filehandle = open(filepath, O_WRONLY | O_TRUNC  | O_CREAT, 0644)) == -1)
	{
		printf("Block Log File Access Error\n");
	}

	RecvFile(sockfd, packetsize, filehandle);
}

void  Spec_Packet(int packettype, int packetsize)
{
	char buffer[9];
	memset(buffer, '\0', 9);
  	memcpy(buffer, &packetsize, 4);
  	memcpy(buffer+4, &packettype, 4);
	
	//  Ȯ Ͽ Ͽ < ϱ Ͽ>
	//printf("packet message :: \n%s\n", buffer+8); 
  	userpool_send(buffer, 8);
}

/***************************************************************
//Define_Packet
//define_packet packet  ϱ  wrapper Լ̴.
//Packet պκп 8byte δ. (int pakcettype) + (int packetsize)
***************************************************************/
void Define_Packet(int packettype, char *packetStr)
{
  	/* * 2007-11-03
	* ȿ  Define_Packet  ʿ packetStr պκ 8Byte    ̴.
	* ׷  ̼ Ͽ ۸  ҴϿ.
	*/
  	char* buffer;
  	int packetsize = 0;
 	   
  	//Ŷ  
  	packetsize = strlen(packetStr);

	/* * 2007-11-03
	* malloc Multi-Thread-Safe ϴ. ׷ signal Լ Safe ʴ Ư¡  ִ.
	* async Լ   ؾ Ұ̴.
	*/
	buffer = (char*)malloc(sizeof(char)*(packetsize+9));

	//Ŷ 
  	memcpy(buffer, &packetsize, 4);
  	memcpy(buffer+4, &packettype, 4);
	memcpy(buffer+8, packetStr, packetsize+1);
	
	//Ȯ Ͽ Ͽ < ϱ Ͽ>
	//printf("packet message :: \n%s\n", buffer+8); 
  	userpool_send(buffer, packetsize+8);
	free(buffer);
}

/***************************************************************
  Լ - EUC-KR => UTF-8 TEXT 
***************************************************************/
int RecvFile(int clnt_sock, int filesize, int filehandle)
{
	char Buff[BUFFSIZE];
	int readCnt = 0;
	char* str;

	//  ޴´.
	printf("File Size %d byte\n", filesize);
	memset(Buff,'\0',sizeof(Buff));
	if(filesize > 0)
	{
		while(1)
		{
			memset(Buff, '\0', sizeof(Buff));

			if(BUFFSIZE >= filesize)
			{
				readCnt = read(clnt_sock, Buff, filesize);
				
				str = conversion_iconv(Buff, "UTF-8", "EUC-KR");
				
				write(filehandle, str, strlen(str));
				
				if(readCnt == filesize)
				{
					break;
				}
				else if(readCnt < filesize)
				{
					filesize -= readCnt;		
				}
			}
			else if(BUFFSIZE < filesize)
			{
				readCnt = read(clnt_sock, Buff, BUFFSIZE);
				
				str = conversion_iconv(Buff, "UTF-8", "EUC-KR");

				if(readCnt == BUFFSIZE)
				{
					filesize -= BUFFSIZE;	
					write(filehandle, str, strlen(str));		
				}
				else if(readCnt < BUFFSIZE)
				{
					filesize -= readCnt;
					write(filehandle, str, strlen(str));		
				}
			}
		}
	}		
	// ڵ ݱ
	close(filehandle);
	return 1;
}

/***************************************************************
  Լ
***************************************************************/
int RecvBiFile(int clnt_sock, int filesize, int filehandle)
{
	char Buff[BUFFSIZE];
	int readCnt = 0;

	//  ޴´.
	printf("File Size %d byte\n", filesize);
	memset(Buff,'\0',sizeof(Buff));
	if(filesize > 0)
	{
		while(1)
		{
			memset(Buff, '\0', sizeof(Buff));

			if(BUFFSIZE >= filesize)
			{
				readCnt = read(clnt_sock, Buff, filesize);
				
				write(filehandle, Buff, readCnt);
				
				if(readCnt == filesize)
				{
					break;
				}
				else if(readCnt < filesize)
				{
					filesize -= readCnt;		
				}
			}
			else if(BUFFSIZE < filesize)
			{
				readCnt = read(clnt_sock, Buff, BUFFSIZE);
				
				if(readCnt == BUFFSIZE)
				{
					filesize -= BUFFSIZE;	
					write(filehandle, Buff, readCnt);		
				}
				else if(readCnt < BUFFSIZE)
				{
					filesize -= readCnt;
					write(filehandle, Buff, readCnt);		
				}
			}
		}
	}		
	// ڵ ݱ
	close(filehandle);
	return 1;
}


/***************************************************************
// // euc-kr -> utf-8 convert or utf-8 -> euc-kr convert
***************************************************************/
char* conversion_iconv (char *inbuf, char *to, char *from)
{
	char *outbuf = NULL, *outbuf_top = NULL;
	size_t bufsize = 0;
	size_t inbytesleft, outbytesleft, status;
	iconv_t handle;

	handle = iconv_open(to, from);
	if (handle == (iconv_t)-1) {
		if (errno == EINVAL) {
			printf("Conversion from %s to %s is not supported. ", to, from);
			exit(1);
		}
		printf("iconv_open failed! "); return inbuf;
	}

	inbytesleft = strlen(inbuf) + 1;
	outbytesleft = 0;

	while (inbytesleft > 0) {
		if (outbytesleft < OUTBUF_LIMIT) {
			size_t outsize = outbuf - outbuf_top;
			outbuf_top = (char *)realloc(outbuf_top, bufsize+=OUTBUF_SIZE);
			if (!outbuf_top) {
				printf("Unable to allocate memory. "); return inbuf;
			}
			
			outbuf = outbuf_top + outsize;
			outbytesleft += OUTBUF_SIZE;
		}
		
		status = iconv(handle, &inbuf, &inbytesleft, &outbuf, &outbytesleft);
		
		if (status == (size_t)-1) {
			if (errno == EINVAL || errno == EILSEQ) {
				printf("Invalid character. ");
				return inbuf;
			}
		}
	}

	return outbuf_top;
} 


/***************************************************************
// Send File
***************************************************************/
int SendFile(int clnt_sock, int filesize, int filehandle)
{
	char Buff[BUFFSIZE];
	int readCnt = 0;
	
	//  Ѵ
	printf("File Size %d byte\n", filesize);
	memset(Buff,'\0',sizeof(Buff));
	
	//ϳ Ѵ.
	if(filesize > 0)
	{
		while((readCnt = read(filehandle, Buff, BUFFSIZE)) != 0)
		{
			userpool_send(Buff, readCnt);
			memset(Buff,'\0',sizeof(Buff));			
		}
	}	
	
	// ڵ ݱ
	close(filehandle);
	return 1;
}

/***************************************************************
// Data Base ؽø 
***************************************************************/
int CompareHashDB(int con, char *filehash)
{

	T_CCI_QUERY_RESULT *qr;

	int req = 0, res = 0;
	char query[200];
	
	memset(query, '\0', 200);
	sprintf(query, "select * from backupfile where fhash LIKE '%%%s%%'", filehash );
	//printf("query = %s\n", query);

	if ((req=cci_prepare(con, query, 0,&error))<0) {
        printf( "%s(%d): cci_prepare fail(%d)\n", __FILE__, __LINE__,error.err_code);
        //goto handle_error;
    }
	printf("Prepare ok!(%d)\n",req);

	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("excute error\n");

		assert(cci_end_tran(con, CCI_TRAN_ROLLBACK, &error) < 0);
	}

	res = cci_execute_result(req, &qr, &error);

	int result_count = 0;
	int i = 0;	

	if (res < 0) {
	  return -1;
	} else {
		for (i=1 ; i <= res ; i++) {
			result_count = CCI_QUERY_RESULT_RESULT(qr, i);
		}

	  cci_query_result_free(qr, res);
	}

	if( result_count == 0 )
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

/***************************************************************
// Backup File  ϱ
***************************************************************/
int FileInfoDBSave(char* filename, char* filehash, int defilehandle, int con)
{

	int req = 0, res = 0;
	int result = 0;
	char buf[500];

	memset(buf, '\0', 500);
	result = CompareHashDB(con, filehash);

	if(result) {
		char query[500];
		memset(query, '\0', 500);
		sprintf(query, "insert into backupfile(fname, fhash) values( '%s', '%s' )", filename, filehash );

		if ((req=cci_prepare(con, query, 0,&error))<0) {
			printf( "%s(%d): cci_prepare fail(%d)\n", __FILE__, __LINE__,error.err_code);
		}
	    
		if ((res = cci_execute(req, 0, 0, &error)) < 0) {
			printf("excute error\n");

			assert(cci_end_tran(con, CCI_TRAN_ROLLBACK, &error) < 0);
		}

		assert(cci_end_tran(con, CCI_TRAN_COMMIT, &error) < 0);
		sprintf(buf, "%s\n%s\n", filename, filehash);
		write(defilehandle, buf, strlen(buf));
	} 
	else 
	{
		printf("duplicate \n");
	}

    return 0;
}

/***************************************************************
// File Log б
***************************************************************/
void FileLogRead(int sockfd, int con)
{
	int cnt = 0;
	int line=0;

	int filehandle = 0;
	int defilehandle = 0;
	
	char ch[1];
	char filename[500];
	char filehash[50];
	
	printf("filelog saving.....\n");
	sprintf(filename, "./LOG/filelog%d.txt", sockfd);
	
	if((filehandle = open(filename, O_RDONLY , 0644)) == -1)
	{
		printf("Filelog File Access Error\n");
	}
	
	memset(filename, '\0', sizeof(filename));
	
	printf("deduplicate file saving.....\n");
	sprintf(filename, "./LOG/dedupleFile%d.txt", sockfd);
			
	if((defilehandle = open(filename, O_WRONLY | O_TRUNC  | O_CREAT, 0644)) == -1)
	{
		printf("Deduplicate File Access Error\n");
	}
	
	// ڿ ʱȭ
	memset(filename, '\0', sizeof(filename));
	memset(filehash, '\0', sizeof(filehash));
	
	while(  read(filehandle, ch, 1) != 0)
	{
		if(ch[0] == '\n')
		{
			cnt = 0;
			line++;
			
			if(line == 3)
			{
				FileInfoDBSave(filename, filehash, defilehandle, con);
				memset(filename, '\0', sizeof(filename));
				memset(filehash, '\0', sizeof(filehash));
				line = 0;
			}
		}
		else if(ch[0] != '\n')
		{
			if(line == 0)
			{
				filename[cnt] = ch[0];
				cnt++;
			}
			else if(line == 1)		
			{
				filehash[cnt] = ch[0];
				cnt++;
			}
		}
	}
	// ݱ
	close(filehandle);
	close(defilehandle);
}
