#ifndef __MAIN_H_
#define __MAIN_H_

#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/epoll.h>
#include <arpa/inet.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
//#include "/usr/include/mysql/mysql.h"

#include <errno.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <math.h>
#include <iconv.h>
#include <cas_cci.h>
#include <pthread.h>


//  

/*
// DBUtile_H
#define DB_HOST 	"localhost"
#define DB_USER 	"root"
#define DB_PASS 	"azwsdcrf"
#define DB_NAME 	"metadata"

MYSQL_RES* sql_result;			//͸ ϱ   ̽ 
MYSQL_ROW sql_row;

int query_stat;					//      
char query[1024];				//   ڿ  
int DBConnection(void);		// ̽  
*/

void DirectoryBackup();
void DirectoryDBSave(char *Path, char *hashhex);
void FileBackup();
void FileDBSave(char* Path, char* filehash, char* dirhash, int filesize, int defilehandle);

void BlockBackup();
// Network_H
#define MAX_CLIENT 10000			//   ִ ִ Ŭ̾Ʈ  
#define DEFAULT_PORT 10568			// Ʈ Ʈ
#define MAX_EVENTS 10000			//ִ  ̺Ʈ   (Ŭ̾Ʈ  )

#define KB8 1

#if KB1
#define BUFFSIZE 1024
#elif KB2
#define BUFFSIZE 2048	
#elif KB4
#define BUFFSIZE 4096
#elif KB8
#define BUFFSIZE 8192
#elif KB16
#define BUFFSIZE 16384
#elif KB32
#define BUFFSIZE 32768
#elif KB64
#define BUFFSIZE 65536
#elif KB128
#define BUFFSIZE 131072
#elif KB256
#define BUFFSIZE 262144
#elif KB512
#define BUFFSIZE 524288
#endif



#define OUTBUF_SIZE 32768
#define OUTBUF_LIMIT 10

typedef struct _clnt{
	int clnt_sockfd;	//Ŭ̾Ʈ  ũ
	char clnt_ip[20];	//Ŭ̾Ʈ  
} clnt;

void clntent_recv(int event_fd);
void epoll_init(void);				//̺Ʈ  
void epoll_clnt_add(int clnt_fd);	//Ŭ̾Ʈ ̺Ʈ  ߰
void init_data(void);				// ۽   ʱȭ
void init_server(int serv_port);	//  , ּ Ʈ, Ŭ̾Ʈ  
void server_process();				//Ŭ̾Ʈ  (Request & Response
void userpool_add(int clnt_fd, char* clnt_ip);	//Ŭ̾Ʈ   user_pool  
void userpool_delete(int clnt_fd);	//Ŭ̾Ʈ   pool 
void userpool_send(char* buffer, int size);	// Ŭ̾Ʈ  

/*
  Creating By 2007-10-31 define_packet packet  ϱ  wrapper Լ̴.
*/
void Define_Packet(int packettype, char *packetStr);

/*
  Creating By 2007-10-31 Ŭ̾Ʈ  ޽ ĽѴ.
*/
int DataParsing(int sockfd, char* message);

void RecvFileLog(int sockfd, int packetsize);
void RecvDirLog(int sockfd, int packetsize);

void Spec_Packet(int packettype, int packetsize);
int SendFile(int clnt_sock, int filesize, int filehandle);
int RecvFile(int clnt_sock, int filesize, int filehandle);

int RecvBiFile(int clnt_sock, int filesize, int filehandle);

void SendDedupleFile(int sockfd);
void SendFileServer(int sockfd);
void SendFileList(int sockfd);

void RecvBlockLog(int sockfd, int packetsize);
void RecvRestoreInfo(int sockfd, int packetsize);
void SendBlockInfo(int sockfd);
void RestoreProcess(int sockfd);
void RestInfoSave(char *hashhex, int sockfd, int filehandle);

// Main
void end_server(int sig);			// 

char* conversion_iconv (char *inbuf, char *to, char *from);

int FileInfoDBSave(char* filename, char* filehash, int defilehandle, int con);
void FileLogRead(int sockfd, int con);

void Cubrid_DisConnection(int con);
int Curbrid_Connection();

int CompareHashDB(int con, char *filehash);
void SendFileListClient(int sockfd);
void RecvTempFile(int sockfd, int packetsize);
void StartDeduplicateFile(int sockfd);
void CoreDeduplicateFile(char* filename);
char hexconvert(char ch);
void* t_function(void *data);
void getListDBQuery(int nDB, int sockfd);
int SendRestoreFiles(int sockfd, int packetsize);


#endif