#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <cas_cci.h>
#include <string.h>
int main (int argc, char *argv[])
{
    int con = 0, req = 0, res, ind, i, col_count;
    T_CCI_ERROR error;
    T_CCI_COL_INFO *res_col_info;
    T_CCI_SQLX_CMD cmd_type;
    char *buffer;
char	buf[512+1];

    char ip[100];
    char db[100];
    char id[100];
    char pa[100];

    memset(ip, '\0', 100);
    memset(db, '\0', 100);
    memset(id, '\0', 100);
    memset(pa, '\0', 100);

    sprintf(ip, "210.115.226.88");
    sprintf(db, "owl");
    sprintf(id, "DBA");
    sprintf(pa, "azws");

    printf("Program started!\n");
    if ((con=cci_connect(ip, 30000, db, id, pa))<0) {
        printf( "%s(%d): cci_connect fail\n", __FILE__, __LINE__);
        return -1;
    }
    else
    {
	printf("%d\n", con);
	printf("success\n");
    }

    if ((con=cci_connect(ip, 30000, db, id, pa))<0) {
        printf( "%s(%d): cci_connect fail\n", __FILE__, __LINE__);
        return -1;
    }
    else
    {
        printf("%d\n", con);
        printf("success\n");
    }
    char query[100];
    memset(query, '\0', 100);
    sprintf(query, "insert into backupfile(fname, fhash) values( '%s', '%s' )", ip, id );
   
    if ((req=cci_prepare(con, query, 0,&error))<0) {
        printf( "%s(%d): cci_prepare fail(%d)\n", __FILE__, __LINE__,error.err_code);
        goto handle_error;
    }

    printf("%s\n", query);
        if ((res = cci_execute(req, 0, 0, &error)) < 0) {
                printf("efifjeijefijef error\n");
                if (cci_end_tran(con, CCI_TRAN_ROLLBACK, &error) < 0) {
                }

        }

        if (cci_end_tran(con, CCI_TRAN_COMMIT, &error) < 0) {
        }
	printf("Prepare ok!(%d)\n",req);
/*
	if ((res = cci_bind_param(req, 1, CCI_A_TYPE_STR, (void *)ip, CCI_U_TYPE_VARNCHAR, (char)NULL)) < 0) {
		cci_get_err_msg (res, buf, 512);
		printf("bind error 1 [%d] %s\n", res, buf);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}
	if ((res = cci_bind_param(req, 2, CCI_A_TYPE_STR, (void *)db, CCI_U_TYPE_VARNCHAR, (char)NULL)) < 0) {
		cci_get_err_msg (res, buf, 512);
		printf("bind error 2 [%d] %s\n", res, buf);
		cci_end_tran(con, CCI_TRAN_ROLLBACK, &error);
		return 0;
	}
*/
	printf("%s\n", query);
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("efifjeijefijef error\n");
                if (cci_end_tran(con, CCI_TRAN_ROLLBACK, &error) < 0) {
                }       

        }
        
        if (cci_end_tran(con, CCI_TRAN_COMMIT, &error) < 0) {
        }

/*
    res_col_info = cci_get_result_info(req, &cmd_type, &col_count);
    if (!res_col_info) {
        printf( "%s(%d): cci_get_result_info fail\n", __FILE__, __LINE__);
        goto handle_error;
    }
   
    printf("Result column information\n"
           "========================================\n");
    for (i=1; i<=col_count; i++) {
        printf("name:%s  type:%d(precision:%d scale:%d)\n",
            CCI_GET_RESULT_INFO_NAME(res_col_info, i),
            CCI_GET_RESULT_INFO_TYPE(res_col_info, i),
            CCI_GET_RESULT_INFO_PRECISION(res_col_info, i),
            CCI_GET_RESULT_INFO_SCALE(res_col_info, i));
    }
    printf("========================================\n");
    if ((res=cci_execute(req, 0, 0, &error))<0) {
        printf( "%s(%d): cci_execute fail(%d)\n", __FILE__, __LINE__,error.err_code);
        goto handle_error;
    }
    if ((res=cci_fetch_size(req, 100))<0) {
        printf( "%s(%d): cci_fetch_size fail\n", __FILE__, __LINE__);
        goto handle_error;
    }
   
    while (1) {
        res = cci_cursor(req, 1, CCI_CURSOR_CURRENT, &error);
        if (res == CCI_ER_NO_MORE_DATA) {
            printf("Query END!\n");
            break;
        }
        if (res<0) {
            printf( "%s(%d): cci_cursor fail(%d)\n", __FILE__, __LINE__,error.err_code);
            goto handle_error;
        }
       
        if ((res=cci_fetch(req, &error))<0) {
            printf( "%s(%d): cci_fetch fail(%d)\n", __FILE__, __LINE__,error.err_code);
            goto handle_error;
        }
       
        for (i=1; i<=col_count; i++) {
            if ((res=cci_get_data(req, i, CCI_A_TYPE_STR, &buffer, &ind))<0) {
                printf( "%s(%d): cci_get_data fail\n", __FILE__, __LINE__);
                goto handle_error;
            }
            printf("%s \t|", buffer);
        }
        printf("\n");
    }
*/
/*
    if ((res=cci_close_req_handle(req))<0) {
           printf( "%s(%d): cci_close_req_handle fail", __FILE__, __LINE__);
           goto handle_error;
    }
*/
    if ((res=cci_disconnect(con, &error))<0) {
          printf( "%s(%d): cci_disconnect fail(%d)", __FILE__, __LINE__,error.err_code);
          goto handle_error;
    }
    printf("Program ended!\n");
    return 0;
   
handle_error:
    printf("error\n");
    if (req > 0)
        cci_close_req_handle(req);
    if (con > 0)
        cci_disconnect(con, &error);
    printf("Program failed!\n");
    return -1;
}
